<?php

namespace Webt\Model;

defined( '_JEXEC' ) or die;

use Joomla\CMS\MVC\Model\BaseDatabaseModel;

/**
 * The BaseTranslatableModel class defines translatable entity base methods and properties.
 *
 * @license     GNU General Public License version 2 or later, see License.txt
 */
class BaseTranslatableModel extends BaseDatabaseModel {

	public $translatableFields = array();

	/**
	 * Retrieves text values of translatable fields for given entity
	 *
	 * @param object $entity Source entity.
	 * @return array String array of translatable values
	 */
	public function getTranslatableFieldValues( $entity ) {
		$translatable_strings = array();
		foreach ( $this->translatableFields as $key => $value ) {
			if ( is_array( $value ) ) {
				$decoded_val = json_decode( $entity->$key, false );
				foreach ( $value as $sub_field ) {
					$translatable_strings[] = $decoded_val->$sub_field;
				}
			} else {
				$translatable_strings[] = $entity->$value;
			}
		}
		return $translatable_strings;
	}
}
